export declare abstract class VBase {
    protected defaultPath: string;
    protected basePath: string;
    protected data: any;
    protected files: string[];
    protected nameless: boolean;
    protected filterEnabled: boolean;
    protected filters: string[];
    protected allowedExt: string[];
    constructor(path: string);
    toAsync(cb: any, self: any): (...args: any[]) => Promise<void>;
    toMethods(): {
        methods: any[];
    };
    get(): any;
    set(data: any): void;
    getFiles(): string[];
    reset(): void;
    addFile(file?: string): void;
    getFile(file: string): object;
    extends(name: string, json: object, data?: any): any;
    generate(data?: {}): {};
    loadOn(): void;
    parseDir(dir?: string): string | false;
    parseFile(dir: any, file: any): false | {
        path: string;
        loaded: any;
    };
    dirReader(dir: any, iterator: any): any;
    load(dir?: any, data?: {}): {};
    protected _filter(file: string): string;
    protected abstract isType(item: any): boolean;
}
