"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var errorable_1 = require("errorable");
var VBase_1 = require("./VBase");
var common = require("errorable-common");
var _ = require("lodash");
var VError = (function (_super) {
    __extends(VError, _super);
    function VError(basePath, locale) {
        if (basePath === void 0) { basePath = ""; }
        if (locale === void 0) { locale = "zh-CN"; }
        var _this = _super.call(this, basePath) || this;
        _this.locale = "zh-CN";
        _this.cache = null;
        _this.nameless = true;
        _this.locale = locale;
        _this.defaultPath = "errors";
        return _this;
    }
    VError.prototype.isType = function (item) {
        return item instanceof Object;
    };
    VError.prototype.set = function (data) {
        _super.prototype.set.call(this, data);
        this.cache = null;
    };
    VError.prototype.parse = function (scope) {
        if (!this.cache) {
            this.cache = this.generate(this.locale, false);
        }
        scope.errors = this.cache;
    };
    VError.prototype.generate = function (locale, filesOnly) {
        if (locale === void 0) { locale = "zh-CN"; }
        if (filesOnly === void 0) { filesOnly = true; }
        var errors = _super.prototype.generate.call(this);
        if (!filesOnly) {
            errors = _.merge(errors, this.data);
        }
        errors = _.merge(errors, common);
        var generator = new errorable_1.Generator(errors, locale);
        return generator.errors;
    };
    return VError;
}(VBase_1.VBase));
exports.VError = VError;
//# sourceMappingURL=VError.js.map