"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = y[op[0] & 2 ? "return" : op[0] ? "throw" : "next"]) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [0, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
var VHTTPBase_1 = require("../Components/VHTTPBase");
var bluebird_1 = require("bluebird");
var parser = require("body-parser");
var skipper = require("skipper");
var VBody = (function (_super) {
    __extends(VBody, _super);
    function VBody(path) {
        var _this = _super.call(this, path) || this;
        _this.defaultPath = "bodies";
        return _this;
    }
    VBody.prototype.isType = function (item) {
        return item instanceof Object;
    };
    VBody.prototype.file = function (req) {
        var _this = this;
        return function (name) { return __awaiter(_this, void 0, void 0, function () {
            var cb;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        cb = bluebird_1.promisify(req.file(name).upload);
                        return [4, cb.call(req.file(name))];
                    case 1: return [2, _a.sent()];
                }
            });
        }); };
    };
    VBody.prototype.parse = function (req, res) {
        return __awaiter(this, void 0, void 0, function () {
            var data, method, _i, _a, k, cb;
            return __generator(this, function (_b) {
                switch (_b.label) {
                    case 0:
                        data = this.check(req);
                        if (!data) {
                            method = req.method.toLowerCase();
                            if (method === "post") {
                                data = {
                                    form: true
                                };
                            }
                            else {
                                return [2, false];
                            }
                        }
                        _i = 0, _a = Object.keys(data);
                        _b.label = 1;
                    case 1:
                        if (!(_i < _a.length)) return [3, 4];
                        k = _a[_i];
                        cb = data[k];
                        if (!cb) {
                            return [3, 3];
                        }
                        if (!(cb instanceof Function)) {
                            switch (k) {
                                case "formdata":
                                case "form":
                                    cb = parser.urlencoded({ extended: false });
                                    cb = this.toAsync(cb, cb);
                                    break;
                                case "xml":
                                    cb = parser.raw({ type: "*/xml" });
                                    cb = this.toAsync(cb, cb);
                                    break;
                                case "json":
                                    cb = parser.json();
                                    cb = this.toAsync(cb, cb);
                                    break;
                                case "file":
                                    cb = skipper();
                                    req.storage = this.file(req);
                                    cb = this.toAsync(cb, cb);
                                    break;
                                default:
                                    return [3, 3];
                            }
                        }
                        return [4, cb(req, res)];
                    case 2:
                        _b.sent();
                        _b.label = 3;
                    case 3:
                        _i++;
                        return [3, 1];
                    case 4: return [2, true];
                }
            });
        });
    };
    return VBody;
}(VHTTPBase_1.VHTTPBase));
exports.VBody = VBody;
//# sourceMappingURL=VBody.js.map