/// <reference types="node" />
import { VHandler } from "./VHandler";
import { Server } from "http";
export declare class VWSServer {
    static ENTER: string;
    static LEAVE: string;
    static getInstance(): VWSServer;
    private static instance;
    server: any;
    eventsAndListeners: object;
    addEventListener(event: string, handler: VHandler): void;
    broadcast(data: any, filter: any): void;
    onEvent(event: any, ws: any, req: any): Promise<void>;
    onEnter(ws: any, req: any): Promise<void>;
    onLeave(ws: any, req: any): Promise<void>;
    onEvents(ws: any, req: any): void;
    start(server: Server): void;
}
